Index: trunk/MagicSoft/Mars/mhist/HistLinkDef.h
===================================================================
--- trunk/MagicSoft/Mars/mhist/HistLinkDef.h	(revision 1968)
+++ trunk/MagicSoft/Mars/mhist/HistLinkDef.h	(revision 1971)
@@ -12,4 +12,5 @@
 
 #pragma link C++ class MBinning+;
+#pragma link C++ class MWeight+;
 
 #pragma link C++ class MHMatrix+;
Index: trunk/MagicSoft/Mars/mhist/MH.h
===================================================================
--- trunk/MagicSoft/Mars/mhist/MH.h	(revision 1968)
+++ trunk/MagicSoft/Mars/mhist/MH.h	(revision 1971)
@@ -15,17 +15,7 @@
 class MBinning;
 class MParList;
-#include <iostream.h>
-#include <TClass.h>
+
 class MH : public MParContainer
 {
-private:
-    /*
-    void Draw(Option_t *opt="")
-    {
-        cout << "MH::Draw" << endl;
-        MParContainer::Draw(opt);
-        }
-        */
-
 public:
     MH(const char *name=NULL, const char *title=NULL);
@@ -77,7 +67,5 @@
     static Double_t GetMinimumGT(const TH1 &h, Double_t gt=0);
 
-
-
-    ClassDef(MH, 1) //A histogram base class for Mars histograms
+    ClassDef(MH, 0) //A base class for Mars histograms
 };
 
Index: trunk/MagicSoft/Mars/mhist/MWeight.cc
===================================================================
--- trunk/MagicSoft/Mars/mhist/MWeight.cc	(revision 1971)
+++ trunk/MagicSoft/Mars/mhist/MWeight.cc	(revision 1971)
@@ -0,0 +1,35 @@
+/* ======================================================================== *\
+!
+! *
+! * This file is part of MARS, the MAGIC Analysis and Reconstruction
+! * Software. It is distributed to you in the hope that it can be a useful
+! * and timesaving tool in analysing Data of imaging Cerenkov telescopes.
+! * It is distributed WITHOUT ANY WARRANTY.
+! *
+! * Permission to use, copy, modify and distribute this software and its
+! * documentation for any purpose is hereby granted without fee,
+! * provided that the above copyright notice appear in all copies and
+! * that both that copyright notice and this permission notice appear
+! * in supporting documentation. It is provided "as is" without express
+! * or implied warranty.
+! *
+!
+!
+!   Author(s): Thomas Bretz  04/2003 <mailto:tbretz@astro.uni-wuerzburg.de>
+!
+!   Copyright: MAGIC Software Development, 2000-2003
+!
+!
+\* ======================================================================== */
+
+/////////////////////////////////////////////////////////////////////////////
+//
+//   MWeight
+//
+//   Storage container for a weight to fill histograms
+//
+/////////////////////////////////////////////////////////////////////////////
+#include "MWeight.h"
+
+ClassImp(MWeight);
+
Index: trunk/MagicSoft/Mars/mhist/MWeight.h
===================================================================
--- trunk/MagicSoft/Mars/mhist/MWeight.h	(revision 1971)
+++ trunk/MagicSoft/Mars/mhist/MWeight.h	(revision 1971)
@@ -0,0 +1,32 @@
+#ifndef MARS_MWeight
+#define MARS_MWeight
+
+/////////////////////////////////////////////////////////////////////////////
+//                                                                         //
+//  MWeight                                                                //
+//                                                                         //
+/////////////////////////////////////////////////////////////////////////////
+
+#ifndef MARS_MParContainer
+#include "MParContainer.h"
+#endif
+
+class MWeight : public MParContainer
+{
+private:
+    Double_t fWeight;
+
+public:
+    MWeight(const char *name=NULL, const char *title=NULL) : fWeight(1)
+    {
+        fName  = name  ? name  : "MWeight";
+        fTitle = title ? title : "A weight for filling histograms";
+    }
+
+    void SetWeight(Double_t weight) { fWeight = weight; }
+    Double_t GetWeight() const { return fWeight; }
+
+    ClassDef(MWeight, 1) // A weight for filling histograms
+};
+
+#endif
Index: trunk/MagicSoft/Mars/mhist/Makefile
===================================================================
--- trunk/MagicSoft/Mars/mhist/Makefile	(revision 1968)
+++ trunk/MagicSoft/Mars/mhist/Makefile	(revision 1971)
@@ -34,4 +34,5 @@
            MH.cc \
            MHArray.cc \
+           MWeight.cc \
            MH3.cc \
            MHCerPhotEvt.cc \