Index: trunk/MagicSoft/Mars/mhist/MFillH.cc
===================================================================
--- trunk/MagicSoft/Mars/mhist/MFillH.cc	(revision 1990)
+++ trunk/MagicSoft/Mars/mhist/MFillH.cc	(revision 1992)
@@ -82,4 +82,6 @@
 #include "MHArray.h"
 
+#include "MWeight.h"
+
 #include "MParList.h"
 #include "MStatusDisplay.h"
@@ -102,4 +104,7 @@
     fIndex  = NULL;
     fCanvas = NULL;
+
+    fWeight     = NULL;
+    fWeightName = "";
 }
 
@@ -350,4 +355,14 @@
             return kFALSE;
         }
+    }
+
+    //
+    // If the user defined the use of a weight: search for it.
+    //
+    if (!fWeight && !fWeightName.IsNull())
+    {
+        fWeight = (MWeight*)pList->FindObject(fWeightName, "MWeight");
+        *fLog << err << fWeightName << " [MWeight] not found... aborting." << endl;
+        return kFALSE;
     }
 
@@ -442,5 +457,5 @@
      */
 
-    return fH->Fill(fParContainer);
+    return fH->Fill(fParContainer, fWeight?fWeight->GetWeight():1);
 } 
 
Index: trunk/MagicSoft/Mars/mhist/MFillH.h
===================================================================
--- trunk/MagicSoft/Mars/mhist/MFillH.h	(revision 1990)
+++ trunk/MagicSoft/Mars/mhist/MFillH.h	(revision 1992)
@@ -9,4 +9,5 @@
 class MMap;
 class MData;
+class MWeight;
 class MParList;
 
@@ -21,4 +22,7 @@
     MH* fH;
     TString fHName;
+
+    MWeight *fWeight;
+    TString fWeightName;
 
     MData *fIndex;    // MData object describing the 'key' to an automatic index for an MHArray
@@ -42,9 +46,11 @@
     MFillH(MH *hist,         const char *par=NULL, const char *name=NULL, const char *title=NULL);
     MFillH(MH *hist,         MParContainer *par,   const char *name=NULL, const char *title=NULL);
-
     ~MFillH();
 
     void SetRuleForIdx(const TString rule);
     void SetRuleForIdx(MData *rule);
+
+    void SetWeight(MWeight *w)       { fWeight = w; }
+    void SetWeight(const char *name) { fWeightName = name; }
 
     Bool_t PreProcess(MParList *pList);
Index: trunk/MagicSoft/Mars/mhist/MH.cc
===================================================================
--- trunk/MagicSoft/Mars/mhist/MH.cc	(revision 1990)
+++ trunk/MagicSoft/Mars/mhist/MH.cc	(revision 1992)
@@ -97,5 +97,5 @@
 // to your class definition.
 //
-Bool_t MH::Fill(const MParContainer *par)
+Bool_t MH::Fill(const MParContainer *par, Double_t w)
 {
     *fLog << warn << GetDescriptor() << ": Fill not overloaded! Can't be used!" << endl;
Index: trunk/MagicSoft/Mars/mhist/MH.h
===================================================================
--- trunk/MagicSoft/Mars/mhist/MH.h	(revision 1990)
+++ trunk/MagicSoft/Mars/mhist/MH.h	(revision 1992)
@@ -22,5 +22,5 @@
 
     virtual Bool_t SetupFill(const MParList *pList) { return kTRUE; }
-    virtual Bool_t Fill(const MParContainer *par);
+    virtual Bool_t Fill(const MParContainer *par, Double_t weight=1);
     virtual Bool_t Finalize() { return kTRUE; }
 
Index: trunk/MagicSoft/Mars/mhist/MHAlphaEnergyTheta.cc
===================================================================
--- trunk/MagicSoft/Mars/mhist/MHAlphaEnergyTheta.cc	(revision 1990)
+++ trunk/MagicSoft/Mars/mhist/MHAlphaEnergyTheta.cc	(revision 1992)
@@ -110,5 +110,5 @@
 // Fill the histogram
 // 
-Bool_t MHAlphaEnergyTheta::Fill(const MParContainer *par)
+Bool_t MHAlphaEnergyTheta::Fill(const MParContainer *par, Double_t w)
 {
     MHillasSrc &hil = *(MHillasSrc*)par;
Index: trunk/MagicSoft/Mars/mhist/MHAlphaEnergyTheta.h
===================================================================
--- trunk/MagicSoft/Mars/mhist/MHAlphaEnergyTheta.h	(revision 1990)
+++ trunk/MagicSoft/Mars/mhist/MHAlphaEnergyTheta.h	(revision 1992)
@@ -33,6 +33,6 @@
     MHAlphaEnergyTheta(const char *name=NULL, const char *title=NULL);
 
-    virtual Bool_t SetupFill(const MParList *pList);
-    virtual Bool_t Fill(const MParContainer *par);
+    Bool_t SetupFill(const MParList *pList);
+    Bool_t Fill(const MParContainer *par, Double_t w=1);
 
     const TH3D *GetHist()       { return &fHist; }
Index: trunk/MagicSoft/Mars/mhist/MHAlphaEnergyTime.cc
===================================================================
--- trunk/MagicSoft/Mars/mhist/MHAlphaEnergyTime.cc	(revision 1990)
+++ trunk/MagicSoft/Mars/mhist/MHAlphaEnergyTime.cc	(revision 1992)
@@ -112,5 +112,5 @@
 // Fill the histogram
 // 
-Bool_t MHAlphaEnergyTime::Fill(const MParContainer *par)
+Bool_t MHAlphaEnergyTime::Fill(const MParContainer *par, Double_t w)
 {
     MHillasSrc &hil = *(MHillasSrc*)par;
Index: trunk/MagicSoft/Mars/mhist/MHAlphaEnergyTime.h
===================================================================
--- trunk/MagicSoft/Mars/mhist/MHAlphaEnergyTime.h	(revision 1990)
+++ trunk/MagicSoft/Mars/mhist/MHAlphaEnergyTime.h	(revision 1992)
@@ -32,6 +32,6 @@
     MHAlphaEnergyTime(const char *name=NULL, const char *title=NULL);
 
-    virtual Bool_t SetupFill(const MParList *pList);
-    virtual Bool_t Fill(const MParContainer *par);
+    Bool_t SetupFill(const MParList *pList);
+    Bool_t Fill(const MParContainer *par, Double_t w=1);
 
     const TH3D *GetHist()       { return &fHist; }
Index: trunk/MagicSoft/Mars/mhist/MHArray.cc
===================================================================
--- trunk/MagicSoft/Mars/mhist/MHArray.cc	(revision 1990)
+++ trunk/MagicSoft/Mars/mhist/MHArray.cc	(revision 1992)
@@ -463,5 +463,5 @@
 // successfull filled.
 //
-Bool_t MHArray::Fill(const MParContainer *par)
+Bool_t MHArray::Fill(const MParContainer *par, Double_t w)
 {
     const Int_t n = fArray->GetSize();
Index: trunk/MagicSoft/Mars/mhist/MHArray.h
===================================================================
--- trunk/MagicSoft/Mars/mhist/MHArray.h	(revision 1990)
+++ trunk/MagicSoft/Mars/mhist/MHArray.h	(revision 1992)
@@ -41,7 +41,7 @@
     void Set(const MH *hist);
 
-    virtual Bool_t SetupFill(const MParList *pList);
-    virtual Bool_t Fill(const MParContainer *par);
-    virtual Bool_t Finalize();
+    Bool_t SetupFill(const MParList *pList);
+    Bool_t Fill(const MParContainer *par, Double_t w=1);
+    Bool_t Finalize();
 
     Bool_t AddHistogram();
Index: trunk/MagicSoft/Mars/mhist/MHBlindPixels.cc
===================================================================
--- trunk/MagicSoft/Mars/mhist/MHBlindPixels.cc	(revision 1990)
+++ trunk/MagicSoft/Mars/mhist/MHBlindPixels.cc	(revision 1992)
@@ -74,5 +74,5 @@
 }
 
-Bool_t MHBlindPixels::Fill(const MParContainer *par)
+Bool_t MHBlindPixels::Fill(const MParContainer *par, Double_t w)
 {
     if (!par)
Index: trunk/MagicSoft/Mars/mhist/MHBlindPixels.h
===================================================================
--- trunk/MagicSoft/Mars/mhist/MHBlindPixels.h	(revision 1990)
+++ trunk/MagicSoft/Mars/mhist/MHBlindPixels.h	(revision 1992)
@@ -23,5 +23,5 @@
 
     void Draw(Option_t* option = "");
-    Bool_t Fill(const MParContainer *par);
+    Bool_t Fill(const MParContainer *par, Double_t w=1);
 
     ClassDef(MHBlindPixels, 1)  // Histogram of blind pixels
Index: trunk/MagicSoft/Mars/mhist/MHCompProb.cc
===================================================================
--- trunk/MagicSoft/Mars/mhist/MHCompProb.cc	(revision 1990)
+++ trunk/MagicSoft/Mars/mhist/MHCompProb.cc	(revision 1992)
@@ -159,5 +159,5 @@
 //
 //
-Bool_t MHCompProb::Fill(const MParContainer *par)
+Bool_t MHCompProb::Fill(const MParContainer *par, Double_t w)
 {
     const MMcEvt &mcevt = *(MMcEvt*)par;
Index: trunk/MagicSoft/Mars/mhist/MHCompProb.h
===================================================================
--- trunk/MagicSoft/Mars/mhist/MHCompProb.h	(revision 1990)
+++ trunk/MagicSoft/Mars/mhist/MHCompProb.h	(revision 1992)
@@ -29,5 +29,5 @@
 
     Bool_t SetupFill(const MParList *plist);
-    Bool_t Fill(const MParContainer *par);
+    Bool_t Fill(const MParContainer *par, Double_t w=1);
     Bool_t Finalize();
 
Index: trunk/MagicSoft/Mars/mhist/MHEffOnTime.cc
===================================================================
--- trunk/MagicSoft/Mars/mhist/MHEffOnTime.cc	(revision 1990)
+++ trunk/MagicSoft/Mars/mhist/MHEffOnTime.cc	(revision 1992)
@@ -361,13 +361,4 @@
 // -------------------------------------------------------------------------
 //
-// Dummy Fill
-//
-Bool_t MHEffOnTime::Fill(const MParContainer *par)
-{
-  return kTRUE;
-}
-
-// -------------------------------------------------------------------------
-//
 // Draw a copy of the histogram
 //
Index: trunk/MagicSoft/Mars/mhist/MHEffOnTime.h
===================================================================
--- trunk/MagicSoft/Mars/mhist/MHEffOnTime.h	(revision 1990)
+++ trunk/MagicSoft/Mars/mhist/MHEffOnTime.h	(revision 1992)
@@ -32,6 +32,5 @@
     MHEffOnTime(const char *varname=NULL, const char *unit=NULL);
 
-    virtual Bool_t SetupFill(const MParList *pList);
-    virtual Bool_t Fill(const MParContainer *par);
+    Bool_t SetupFill(const MParList *pList);
 
     const TH1D *GetHist() { return &fHEffOn; }
Index: trunk/MagicSoft/Mars/mhist/MHEffOnTimeTheta.cc
===================================================================
--- trunk/MagicSoft/Mars/mhist/MHEffOnTimeTheta.cc	(revision 1990)
+++ trunk/MagicSoft/Mars/mhist/MHEffOnTimeTheta.cc	(revision 1992)
@@ -257,15 +257,4 @@
 // -------------------------------------------------------------------------
 //
-// Dummy Fill
-// without it get the error message :
-// Error: MHEffOnTimeTime() no default constructor FILE:macros/wowflux.C LINE:359
-// *** Interpreter error recovered ***
-//
-Bool_t MHEffOnTimeTheta::Fill(const MParContainer *par)
-{
-  return kTRUE; 
-}     
-// -------------------------------------------------------------------------
-//
 // Draw a copy of the histogram
 //
Index: trunk/MagicSoft/Mars/mhist/MHEffOnTimeTheta.h
===================================================================
--- trunk/MagicSoft/Mars/mhist/MHEffOnTimeTheta.h	(revision 1990)
+++ trunk/MagicSoft/Mars/mhist/MHEffOnTimeTheta.h	(revision 1992)
@@ -24,6 +24,5 @@
     MHEffOnTimeTheta(const char *name=NULL, const char *title=NULL);
 
-    virtual Bool_t SetupFill(const MParList *pList);
-    virtual Bool_t Fill(const MParContainer *par);
+    Bool_t SetupFill(const MParList *pList);
 
     const TH1D *GetHist() { return &fHEffOn; }
Index: trunk/MagicSoft/Mars/mhist/MHEffOnTimeTime.cc
===================================================================
--- trunk/MagicSoft/Mars/mhist/MHEffOnTimeTime.cc	(revision 1990)
+++ trunk/MagicSoft/Mars/mhist/MHEffOnTimeTime.cc	(revision 1992)
@@ -264,15 +264,4 @@
 // -------------------------------------------------------------------------
 //
-// Dummy Fill
-// without it get error message :
-// Error: MHEffOnTimeTime() no default constructor FILE:macros/wowflux.C LINE:359
-//*** Interpreter error recovered ***
-Bool_t MHEffOnTimeTime::Fill(const MParContainer *par)
-{
-  return kTRUE;
-}
-
-// -------------------------------------------------------------------------
-//
 // Draw a copy of the histogram
 //
Index: trunk/MagicSoft/Mars/mhist/MHEffOnTimeTime.h
===================================================================
--- trunk/MagicSoft/Mars/mhist/MHEffOnTimeTime.h	(revision 1990)
+++ trunk/MagicSoft/Mars/mhist/MHEffOnTimeTime.h	(revision 1992)
@@ -24,6 +24,5 @@
     MHEffOnTimeTime(const char *name=NULL, const char *title=NULL);
 
-    virtual Bool_t SetupFill(const MParList *pList);
-    virtual Bool_t Fill(const MParContainer *par);
+    Bool_t SetupFill(const MParList *pList);
 
     const TH1D *GetHist() { return &fHEffOn; }
Index: trunk/MagicSoft/Mars/mhist/MHEnergyTheta.cc
===================================================================
--- trunk/MagicSoft/Mars/mhist/MHEnergyTheta.cc	(revision 1990)
+++ trunk/MagicSoft/Mars/mhist/MHEnergyTheta.cc	(revision 1992)
@@ -99,5 +99,5 @@
 // Fill data into the histogram which contains all showers
 //
-Bool_t MHEnergyTheta::Fill(const MParContainer *par)
+Bool_t MHEnergyTheta::Fill(const MParContainer *par, Double_t w)
 {
     const MMcEvt &mcevt = *(MMcEvt*)par;
Index: trunk/MagicSoft/Mars/mhist/MHEnergyTheta.h
===================================================================
--- trunk/MagicSoft/Mars/mhist/MHEnergyTheta.h	(revision 1990)
+++ trunk/MagicSoft/Mars/mhist/MHEnergyTheta.h	(revision 1992)
@@ -22,5 +22,5 @@
     ~MHEnergyTheta();
 
-    Bool_t Fill(const MParContainer *cont);
+    Bool_t Fill(const MParContainer *cont, Double_t w=1);
 
     void Draw(Option_t *option="");
Index: trunk/MagicSoft/Mars/mhist/MHFadcCam.cc
===================================================================
--- trunk/MagicSoft/Mars/mhist/MHFadcCam.cc	(revision 1990)
+++ trunk/MagicSoft/Mars/mhist/MHFadcCam.cc	(revision 1992)
@@ -91,5 +91,5 @@
 
 // --------------------------------------------------------------------------
-Bool_t MHFadcCam::Fill(const MParContainer *par)
+Bool_t MHFadcCam::Fill(const MParContainer *par, Double_t w)
 {
     return Fill((MRawEvtData*)par);
@@ -138,2 +138,3 @@
     GetHistLo(i)->Reset();
 }
+
Index: trunk/MagicSoft/Mars/mhist/MHFadcCam.h
===================================================================
--- trunk/MagicSoft/Mars/mhist/MHFadcCam.h	(revision 1990)
+++ trunk/MagicSoft/Mars/mhist/MHFadcCam.h	(revision 1992)
@@ -45,5 +45,5 @@
     const TH1F *GetHistLo(UInt_t i) const { return (*this)[i].GetHistLo(); }
 
-    Bool_t Fill(const MParContainer *par);
+    Bool_t Fill(const MParContainer *par, Double_t w=1);
     Bool_t Fill(const MRawEvtData *par);
 
Index: trunk/MagicSoft/Mars/mhist/MHFlux.cc
===================================================================
--- trunk/MagicSoft/Mars/mhist/MHFlux.cc	(revision 1990)
+++ trunk/MagicSoft/Mars/mhist/MHFlux.cc	(revision 1992)
@@ -185,24 +185,4 @@
 // -------------------------------------------------------------------------
 //
-// Dummy Fill (has to be included because in base class MH Fill is set to 0 
-//             (abstract member function));
-// without the dummy Fill one gets the error message :
-//
-// Error: Can't call MHFlux::MHFlux(evttime,"time","[s]") in current scope 
-// FILE:macros/flux.C LINE:465
-// Possible candidates are...
-// filename       line:size busy function type and name  (in MHFlux)
-// filename       line:size busy function type and name  (in MH)
-// filename       line:size busy function type and name  (in MParContainer)
-// filename       line:size busy function type and name  (in TObject)
-//
-Bool_t MHFlux::Fill(const MParContainer *par)
-{
-    return kTRUE;
-}
-
-
-// -------------------------------------------------------------------------
-//
 // Unfold the distribution in E-est
 //
Index: trunk/MagicSoft/Mars/mhist/MHFlux.h
===================================================================
--- trunk/MagicSoft/Mars/mhist/MHFlux.h	(revision 1990)
+++ trunk/MagicSoft/Mars/mhist/MHFlux.h	(revision 1992)
@@ -50,6 +50,4 @@
     MHFlux(const MHGamma &h2d, const TString varname, const TString unit);
 
-    Bool_t Fill(const MParContainer *par);
-
     void Unfold();
     void CalcFlux(const TH1D *teff, const TProfile *thetabar,
Index: trunk/MagicSoft/Mars/mhist/MHGamma.cc
===================================================================
--- trunk/MagicSoft/Mars/mhist/MHGamma.cc	(revision 1990)
+++ trunk/MagicSoft/Mars/mhist/MHGamma.cc	(revision 1992)
@@ -60,13 +60,4 @@
 }
 
-// --------------------------------------------------------------------------
-//
-// Dummy Fill
-//
-Bool_t MHGamma::Fill(const MParContainer *par)
-{
-  return kTRUE;
-}
-
 TH3D *MHGamma::Subtract(const MHAlphaEnergyTheta &h1, const MHAlphaEnergyTheta &h2)
 {
Index: trunk/MagicSoft/Mars/mhist/MHGamma.h
===================================================================
--- trunk/MagicSoft/Mars/mhist/MHGamma.h	(revision 1990)
+++ trunk/MagicSoft/Mars/mhist/MHGamma.h	(revision 1992)
@@ -23,6 +23,4 @@
     MHGamma(const TString &name="", const TString &title="");
 
-    Bool_t Fill(const MParContainer *par);
-
     TH3D *Subtract(const TH3D *h1, const TH3D *h2);
 
Index: trunk/MagicSoft/Mars/mhist/MHHadronness.cc
===================================================================
--- trunk/MagicSoft/Mars/mhist/MHHadronness.cc	(revision 1990)
+++ trunk/MagicSoft/Mars/mhist/MHHadronness.cc	(revision 1992)
@@ -183,5 +183,5 @@
 // are skipped at the moment.
 //
-Bool_t MHHadronness::Fill(const MParContainer *par)
+Bool_t MHHadronness::Fill(const MParContainer *par, Double_t w)
 {
     // Preliminary Workaround: FIXME!
Index: trunk/MagicSoft/Mars/mhist/MHHadronness.h
===================================================================
--- trunk/MagicSoft/Mars/mhist/MHHadronness.h	(revision 1990)
+++ trunk/MagicSoft/Mars/mhist/MHHadronness.h	(revision 1992)
@@ -45,5 +45,5 @@
 
     Bool_t SetupFill(const MParList *plist);
-    Bool_t Fill(const MParContainer *par);
+    Bool_t Fill(const MParContainer *par, Double_t w=1);
     Bool_t Finalize();
 
Index: trunk/MagicSoft/Mars/mhist/MHMatrix.cc
===================================================================
--- trunk/MagicSoft/Mars/mhist/MHMatrix.cc	(revision 1990)
+++ trunk/MagicSoft/Mars/mhist/MHMatrix.cc	(revision 1992)
@@ -227,5 +227,5 @@
 // Add the values correspoding to the columns to the new row
 //
-Bool_t MHMatrix::Fill(const MParContainer *par)
+Bool_t MHMatrix::Fill(const MParContainer *par, Double_t w)
 {
     AddRow();
Index: trunk/MagicSoft/Mars/mhist/MHMatrix.h
===================================================================
--- trunk/MagicSoft/Mars/mhist/MHMatrix.h	(revision 1990)
+++ trunk/MagicSoft/Mars/mhist/MHMatrix.h	(revision 1992)
@@ -48,5 +48,5 @@
     Bool_t SetupFill(const MParList *pList);
 
-    Bool_t Fill(const MParContainer *par);
+    Bool_t Fill(const MParContainer *par, Double_t w=1);
     Bool_t Finalize();
 
Index: trunk/MagicSoft/Mars/mhist/MHRanForest.cc
===================================================================
--- trunk/MagicSoft/Mars/mhist/MHRanForest.cc	(revision 1990)
+++ trunk/MagicSoft/Mars/mhist/MHRanForest.cc	(revision 1992)
@@ -108,5 +108,5 @@
 //
 //
-Bool_t MHRanForest::Fill(const MParContainer *par)
+Bool_t MHRanForest::Fill(const MParContainer *par, Double_t w)
 {
     fNumEvent++;
Index: trunk/MagicSoft/Mars/mhist/MHRanForest.h
===================================================================
--- trunk/MagicSoft/Mars/mhist/MHRanForest.h	(revision 1990)
+++ trunk/MagicSoft/Mars/mhist/MHRanForest.h	(revision 1992)
@@ -33,5 +33,5 @@
 
     Bool_t SetupFill(const MParList *plist);
-    Bool_t Fill(const MParContainer *par);
+    Bool_t Fill(const MParContainer *par, Double_t w=1);
     Bool_t Finalize();
 
Index: trunk/MagicSoft/Mars/mhist/MHRanForestGini.cc
===================================================================
--- trunk/MagicSoft/Mars/mhist/MHRanForestGini.cc	(revision 1990)
+++ trunk/MagicSoft/Mars/mhist/MHRanForestGini.cc	(revision 1992)
@@ -101,5 +101,5 @@
 //
 //
-Bool_t MHRanForestGini::Fill(const MParContainer *par)
+Bool_t MHRanForestGini::Fill(const MParContainer *par, Double_t w)
 {
     for (Int_t i=0;i<fRanForest->GetNumDim();i++)
Index: trunk/MagicSoft/Mars/mhist/MHRanForestGini.h
===================================================================
--- trunk/MagicSoft/Mars/mhist/MHRanForestGini.h	(revision 1990)
+++ trunk/MagicSoft/Mars/mhist/MHRanForestGini.h	(revision 1992)
@@ -31,5 +31,5 @@
 
     Bool_t SetupFill(const MParList *plist);
-    Bool_t Fill(const MParContainer *par);
+    Bool_t Fill(const MParContainer *par, Double_t w=1);
     Bool_t Finalize();
 
Index: trunk/MagicSoft/Mars/mhist/MHSigmaPixel.cc
===================================================================
--- trunk/MagicSoft/Mars/mhist/MHSigmaPixel.cc	(revision 1990)
+++ trunk/MagicSoft/Mars/mhist/MHSigmaPixel.cc	(revision 1992)
@@ -107,5 +107,5 @@
 // Fill the histogram
 // 
-Bool_t MHSigmaPixel::Fill(const MParContainer *par)
+Bool_t MHSigmaPixel::Fill(const MParContainer *par, Double_t w)
 {
     const MPedestalCam &ped = *(MPedestalCam*)par;
Index: trunk/MagicSoft/Mars/mhist/MHSigmaPixel.h
===================================================================
--- trunk/MagicSoft/Mars/mhist/MHSigmaPixel.h	(revision 1990)
+++ trunk/MagicSoft/Mars/mhist/MHSigmaPixel.h	(revision 1992)
@@ -26,6 +26,6 @@
     MHSigmaPixel(const char *name=NULL, const char *title=NULL);
 
-    virtual Bool_t SetupFill(const MParList *pList);
-    virtual Bool_t Fill(const MParContainer *par);
+    Bool_t SetupFill(const MParList *pList);
+    Bool_t Fill(const MParContainer *par, Double_t w=1);
 
     const TH2D *GetHist()       { return &fHist; }
Index: trunk/MagicSoft/Mars/mhist/MHSigmaTheta.cc
===================================================================
--- trunk/MagicSoft/Mars/mhist/MHSigmaTheta.cc	(revision 1990)
+++ trunk/MagicSoft/Mars/mhist/MHSigmaTheta.cc	(revision 1992)
@@ -177,5 +177,5 @@
 //  Fill the histograms
 //
-Bool_t MHSigmaTheta::Fill(const MParContainer *par)
+Bool_t MHSigmaTheta::Fill(const MParContainer *par, Double_t w)
 {
     Double_t theta = fMcEvt->GetTelescopeTheta()*kRad2Deg;
Index: trunk/MagicSoft/Mars/mhist/MHSigmaTheta.h
===================================================================
--- trunk/MagicSoft/Mars/mhist/MHSigmaTheta.h	(revision 1990)
+++ trunk/MagicSoft/Mars/mhist/MHSigmaTheta.h	(revision 1992)
@@ -44,5 +44,5 @@
 
     Bool_t SetupFill(const MParList *plist);
-    Bool_t Fill(const MParContainer *par);
+    Bool_t Fill(const MParContainer *par, Double_t w=1);
 
     const TH2D *GetSigmaTheta() { return &fSigmaTheta; }
Index: trunk/MagicSoft/Mars/mhist/MHSigmabarTheta.cc
===================================================================
--- trunk/MagicSoft/Mars/mhist/MHSigmabarTheta.cc	(revision 1990)
+++ trunk/MagicSoft/Mars/mhist/MHSigmabarTheta.cc	(revision 1992)
@@ -111,5 +111,5 @@
 // Fill the histogram
 // 
-Bool_t MHSigmabarTheta::Fill(const MParContainer *par)
+Bool_t MHSigmabarTheta::Fill(const MParContainer *par, Double_t w)
 {
     fHist.Fill(fMcEvt->GetTheta()*kRad2Deg, fSigmabar->GetSigmabar());  
Index: trunk/MagicSoft/Mars/mhist/MHSigmabarTheta.h
===================================================================
--- trunk/MagicSoft/Mars/mhist/MHSigmabarTheta.h	(revision 1990)
+++ trunk/MagicSoft/Mars/mhist/MHSigmabarTheta.h	(revision 1992)
@@ -27,6 +27,6 @@
     MHSigmabarTheta(const char *name=NULL, const char *title=NULL);
 
-    virtual Bool_t SetupFill(const MParList *pList);
-    virtual Bool_t Fill(const MParContainer *par);
+    Bool_t SetupFill(const MParList *pList);
+    Bool_t Fill(const MParContainer *par, Double_t w=1);
 
     const TH2D *GetHist()       { return &fHist; }
Index: trunk/MagicSoft/Mars/mhist/MHStarMap.cc
===================================================================
--- trunk/MagicSoft/Mars/mhist/MHStarMap.cc	(revision 1990)
+++ trunk/MagicSoft/Mars/mhist/MHStarMap.cc	(revision 1992)
@@ -146,5 +146,5 @@
 // Be careful: Only call this with an object of type MHillas
 //
-Bool_t MHStarMap::Fill(const MParContainer *par)
+Bool_t MHStarMap::Fill(const MParContainer *par, Double_t w)
 {
     const MHillas &h = *(MHillas*)par;
Index: trunk/MagicSoft/Mars/mhist/MHStarMap.h
===================================================================
--- trunk/MagicSoft/Mars/mhist/MHStarMap.h	(revision 1990)
+++ trunk/MagicSoft/Mars/mhist/MHStarMap.h	(revision 1992)
@@ -33,5 +33,5 @@
 
     Bool_t SetupFill(const MParList *pList);
-    Bool_t Fill(const MParContainer *par);
+    Bool_t Fill(const MParContainer *par, Double_t w=1);
 
     TH1 *GetHistByName(const TString name) { return fStarMap; }
Index: trunk/MagicSoft/Mars/mhist/MHThetabarTheta.cc
===================================================================
--- trunk/MagicSoft/Mars/mhist/MHThetabarTheta.cc	(revision 1990)
+++ trunk/MagicSoft/Mars/mhist/MHThetabarTheta.cc	(revision 1992)
@@ -110,5 +110,5 @@
 // Fill the histogram
 //
-Bool_t MHThetabarTheta::Fill(const MParContainer *par)
+Bool_t MHThetabarTheta::Fill(const MParContainer *par, Double_t w)
 {
     const Double_t theta = fMcEvt->GetTelescopeTheta()*kRad2Deg;
Index: trunk/MagicSoft/Mars/mhist/MHThetabarTheta.h
===================================================================
--- trunk/MagicSoft/Mars/mhist/MHThetabarTheta.h	(revision 1990)
+++ trunk/MagicSoft/Mars/mhist/MHThetabarTheta.h	(revision 1992)
@@ -25,6 +25,6 @@
     MHThetabarTheta(const char *name=NULL, const char *title=NULL);
 
-    virtual Bool_t SetupFill(const MParList *pList);
-    virtual Bool_t Fill(const MParContainer *par);
+    Bool_t SetupFill(const MParList *pList);
+    Bool_t Fill(const MParContainer *par, Double_t w=1);
 
     const TProfile *GetHist() { return &fHist; }
Index: trunk/MagicSoft/Mars/mhist/MHThetabarTime.h
===================================================================
--- trunk/MagicSoft/Mars/mhist/MHThetabarTime.h	(revision 1990)
+++ trunk/MagicSoft/Mars/mhist/MHThetabarTime.h	(revision 1992)
@@ -28,6 +28,6 @@
     MHThetabarTime(const char *name=NULL, const char *title=NULL);
 
-    virtual Bool_t SetupFill(const MParList *pList);
-    virtual Bool_t Fill(const MParContainer *par);
+    Bool_t SetupFill(const MParList *pList);
+    Bool_t Fill(const MParContainer *par, Double_t w=1);
 
     const TProfile *GetHist() { return &fHist; }
Index: trunk/MagicSoft/Mars/mhist/MHTimeDiffTheta.cc
===================================================================
--- trunk/MagicSoft/Mars/mhist/MHTimeDiffTheta.cc	(revision 1990)
+++ trunk/MagicSoft/Mars/mhist/MHTimeDiffTheta.cc	(revision 1992)
@@ -143,5 +143,5 @@
 //  Fill the histogram
 //
-Bool_t MHTimeDiffTheta::Fill(const MParContainer *par)
+Bool_t MHTimeDiffTheta::Fill(const MParContainer *par, Double_t w)
 {
     const Double_t time = 200e-9*fTime->GetTimeLo() + fTime->GetTimeHi();
Index: trunk/MagicSoft/Mars/mhist/MHTimeDiffTheta.h
===================================================================
--- trunk/MagicSoft/Mars/mhist/MHTimeDiffTheta.h	(revision 1990)
+++ trunk/MagicSoft/Mars/mhist/MHTimeDiffTheta.h	(revision 1992)
@@ -26,6 +26,6 @@
     MHTimeDiffTheta(const char *name=NULL, const char *title=NULL);
 
-    virtual Bool_t SetupFill(const MParList *pList);
-    virtual Bool_t Fill(const MParContainer *par);
+    Bool_t SetupFill(const MParList *pList);
+    Bool_t Fill(const MParContainer *par, Double_t w=1);
 
     const TH2D *GetHist() { return &fHist; }
Index: trunk/MagicSoft/Mars/mhist/MHTimeDiffTime.cc
===================================================================
--- trunk/MagicSoft/Mars/mhist/MHTimeDiffTime.cc	(revision 1990)
+++ trunk/MagicSoft/Mars/mhist/MHTimeDiffTime.cc	(revision 1992)
@@ -136,5 +136,5 @@
 //  Fill the histogram
 //
-Bool_t MHTimeDiffTime::Fill(const MParContainer *par)
+Bool_t MHTimeDiffTime::Fill(const MParContainer *par, Double_t w)
 {
     const Double_t time = 200e-9*fTime->GetTimeLo() + fTime->GetTimeHi();
Index: trunk/MagicSoft/Mars/mhist/MHTimeDiffTime.h
===================================================================
--- trunk/MagicSoft/Mars/mhist/MHTimeDiffTime.h	(revision 1990)
+++ trunk/MagicSoft/Mars/mhist/MHTimeDiffTime.h	(revision 1992)
@@ -25,5 +25,5 @@
 
     virtual Bool_t SetupFill(const MParList *pList);
-    virtual Bool_t Fill(const MParContainer *par);
+    virtual Bool_t Fill(const MParContainer *par, Double_t w=1);
 
     const TH2D *GetHist() { return &fHist; }