Index: trunk/MagicSoft/Cosy/gui/MGCosy.cc
===================================================================
--- trunk/MagicSoft/Cosy/gui/MGCosy.cc	(revision 1959)
+++ trunk/MagicSoft/Cosy/gui/MGCosy.cc	(revision 2068)
@@ -10,12 +10,12 @@
 #include <TGTab.h>         // TGTab
 #include <TGMenu.h>        // TGPopupMenu
-#include <TGButton.h>      // TGButton
+#include <TGFrame.h>       // TGGroupFrame
 #include <TSystem.h>       // gSystem
 #include <TGLabel.h>       // TGLabel
-#include <TGListBox.h>     // TGListBox
+#include <TG3DLine.h>      // TGHorizontal3DLine (TGSplitter)
+#include <TGButton.h>      // TGButton
+#include <TGTextView.h>    // TGTextView
 #include <TGComboBox.h>    // TGComboBox
-#include <TG3DLine.h>      // TGHorizontal3DLine (TGSplitter)
 #include <TGTextEntry.h>   // TGTextEntry
-#include <TGFrame.h>       // TGGroupFrame
 #include <TApplication.h>  // gApplication
 
@@ -621,4 +621,6 @@
     fList = new MGList;
 
+    fFont = gVirtualX->LoadQueryFont("7x13bold");
+
 #ifdef DEBUG
     cout << "MGCosy: Creating Menu" << endl;
@@ -647,9 +649,9 @@
     cout << "MGCosy: Creating MGAccuracy" << endl;
 #endif
-    fAccuracy    = new MGAccuracy   (f1, 300);
+    fAccuracy = new MGAccuracy(f1, 300);
 #ifdef DEBUG
     cout << "MGCosy: Creating MGVelocity" << endl;
 #endif
-    fVelocity    = new MGVelocity   (f2, "Velocity [\"/min]", 300);
+    fVelocity = new MGVelocity(f2, "Velocity [\"/min]", 300);
 //    fOffset      = new MGVelocity   (f, "Offset se-re [']", 300);
 
@@ -663,13 +665,12 @@
 #endif
     TGGroupFrame *frame = new TGGroupFrame(f2, "Status");
-    frame->Resize(300, 300);
     fList->Add(frame);
 
 #ifdef DEBUG
-    cout << "MGCosy: Creating TGListBox" << endl;
-#endif
-    fLog = new TGListBox(f2, -1, kSunkenFrame);  //kSunkenFrame|kDoubleBorder,
-    fLog->Resize(300, 300);
-    fLog->ChangeBackground(TGFrame::GetBlackPixel());
+    cout << "MGCosy: Creating TGTextView" << endl;
+#endif
+    fLog = new TGTextView(f2, 300, 300);
+    if (fFont)
+        fLog->SetFont(fFont);
     fList->Add(fLog);
 
@@ -743,14 +744,21 @@
 MGCosy::~MGCosy()
 {
+#ifdef DEBUG
     cout << "MGCosy::~MGCosy called." << endl;
-
+#endif
     delete fLayMenuBar;
     delete fLayMenuItem;
-
+#ifdef DEBUG
     cout << "Deleting MGCosy::fList" << endl;
-
+#endif
     delete fList;
-
+#ifdef DEBUG
+    cout << "Deleting MGCosy::fFont" << endl;
+#endif
+    if (fFont)
+        gVirtualX->DeleteFont(fFont);
+#ifdef DEBUG
     cout << "MGCosy::~MGCosy done." << endl;
+#endif
 }
 
@@ -971,4 +979,5 @@
     //    stat&kTracking ? fOffset->MapWindow()   : fOffset->UnmapWindow();
 
+/*
     if (fLog->TestBit(kHasChanged))
     {
@@ -976,5 +985,5 @@
         fLog->Layout();
         fLog->ResetBit(kHasChanged);
-    }
+    }*/
 }
 // ======================================================================
Index: trunk/MagicSoft/Cosy/gui/MGCosy.h
===================================================================
--- trunk/MagicSoft/Cosy/gui/MGCosy.h	(revision 1959)
+++ trunk/MagicSoft/Cosy/gui/MGCosy.h	(revision 2068)
@@ -16,12 +16,12 @@
 class TIterator;
 
+class TGTab;
 class TGLabel;
+class TGMenuBar;
+class TGTextView;
 class TGPopupMenu;
-class TGMenuBar;
-class TGHorizontal3DLine;
 class TGLayoutHints;
 class TGCompositeFrame;
-class TGTab;
-class TGListBox;
+class TGHorizontal3DLine;
 
 class ZdAz;
@@ -29,10 +29,10 @@
 class MsgQueue;
 
+class MGList;
 class MGImage;
-class MGList;
+class MGAccuracy;
+class MGVelocity;
 class MGCoordinates;
 class MGSkyPosition;
-class MGAccuracy;
-class MGVelocity;
 
 class MGCosy : public TGMainFrame
@@ -95,5 +95,7 @@
     TGLabel *fAvailSe3;
 
-    TGListBox *fLog;
+    TGTextView *fLog;
+
+    FontStruct_t fFont;
 
     void CreateMenu();
@@ -126,5 +128,5 @@
     TGLabel *GetLabel3() const { return fLabel3; }
 
-    TGListBox *GetLog() const { return fLog; }
+    TGTextView *GetLog() const { return fLog; }
 
     void Update(ZdAz pos, ZdAz acc, ZdAz vel, ZdAz off, RaDec radec, ZdAz soll, UInt_t stat, UInt_t stat2);